//+------------------------------------------------------------------+
//| Close First Activ Order.mq4                                      |
//| SwingMan, 2010.03.10                                             |
//+------------------------------------------------------------------+
#property copyright "SwingMan, 2010.03.10"
#property link ""
#property show_confirm

//+------------------------------------------------------------------+
//| script program start function |
//+------------------------------------------------------------------+
int i,total,err;
int iOrderTicket[20];
datetime dOrderOpenTime[20];
int nActivOrders;
int firstTicket;
datetime firstOpenTime;

//____________________________________________________________________
int start()
{
   Get_ActivOrders();

   if (nActivOrders > 0)
   {
      Get_FirstActivOrder();
      Close_FirstActivOrder();
   }
   return(0);
}
//+------------------------------------------------------------------+


//____________________________________________________________________
void Get_ActivOrders()
{
   total = OrdersTotal();
   nActivOrders = 0;
   for (int i=0; i <=total; i++)
   {
      if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderCloseTime() == 0)
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)
            {
               nActivOrders++;
               iOrderTicket[nActivOrders]   = OrderTicket();
               dOrderOpenTime[nActivOrders] = OrderOpenTime();
            }         
      }      
   }
}

//____________________________________________________________________
void Get_FirstActivOrder()
{
   firstTicket   = iOrderTicket[1];
   firstOpenTime = dOrderOpenTime[1];
   
   for (int i=2; i<=nActivOrders; i++)
   {
      if (dOrderOpenTime[i] < firstOpenTime)
      {
         firstTicket   = iOrderTicket[i];
         firstOpenTime = dOrderOpenTime[i];
      }
   }
}

//____________________________________________________________________
void Close_FirstActivOrder()
{
   if(OrderSelect(firstTicket,SELECT_BY_TICKET))
   {
         if(OrderType()==OP_BUY)
         {
            OrderClose(firstTicket,OrderLots(),Bid,10,Blue);
            err=GetLastError();
            while(err==129)
            {
               RefreshRates();
               //Sleep(100);
               OrderClose(firstTicket,OrderLots(),Bid,10,Blue);
               err=GetLastError();
            }
            Print("Buy Error: ",err);
         }
         if(OrderType()==OP_SELL)
         {
            OrderClose(firstTicket,OrderLots(),Ask,10,Red);
            err=GetLastError();
            while(err==129)
            {
               RefreshRates();
               //Sleep(100);
               OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
               err=GetLastError();
            } 
            Print("Sell Error: ",err);
         }
   }
}

